///////////////////////////////////////////////////////////////////////////////////////////////////
//							      
//							http://www.interestprograms.ru
//
///////////////////////////////////////////////////////////////////////////////////////////////////

// ExRgnWin32.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ExRgnWin32.h"
#define MAX_LOADSTRING 100


//    
#define DELGDIOBJECT(handle) if(handle != NULL){DeleteObject(handle); handle = NULL;}


// Global Variables:
HINSTANCE hInst;								// current instance
HWND hWnd;
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);


//////////////////////////////////////////////////////////////////////////////////////////////
//  
HMENU hMenu		= NULL;		//      
HBITMAP hBmp	= NULL;		//    
HRGN hRgn		= NULL;		//   
HRGN GetRgn(UINT id_res);	//  
void ViewChange();			//   
void ReturnView();			//   
void DeleteObjects();		//   GDI 



int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_EXRGNWIN32, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_EXRGNWIN32);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_EXRGNWIN32);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH) GetStockObject(BLACK_BRUSH);
	wcex.lpszMenuName	= (LPCTSTR)IDC_EXRGNWIN32;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;

		
		//   
		case IDM_TEST1:
			{
				//   
				ViewChange();
				
				//     
				DeleteObjects();
				
				hBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP1));

				//    
				// rgn      
				//          (.MSDN)
				HRGN rgn = GetRgn(IDR_RGN1);
				SetWindowRgn(hWnd, rgn, TRUE);
			}
			break;
		case IDM_TEST2:
			{
				//   
				ViewChange();

				//     
				DeleteObjects();

				hBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP2));

				//    
				// rgn      
				//          (.MSDN)
				HRGN rgn = GetRgn(IDR_RGN2);
				SetWindowRgn(hWnd, rgn, TRUE);
			}
			break;
		case IDM_TEST3:
			{
				//   
				ViewChange();

				//     
				DeleteObjects();

				hBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP3));

				//    
				// rgn      
				//          (.MSDN)
				HRGN rgn = GetRgn(IDR_RGN3);
				SetWindowRgn(hWnd, rgn, TRUE);
			}
			break;
		case IDM_TEST4:
			{
				//     
				DeleteObjects();

				hRgn = GetRgn(IDR_RGN1);
				RECT rc;
				//GetRgnBox(hRgn, &rc);
				GetClientRect(hWnd, &rc);
				InvalidateRect(hWnd, &rc, TRUE);
			}
			break;
		case IDM_TEST5:
			{
				//     
				DeleteObjects();

				hRgn = GetRgn(IDR_RGN2);
				RECT rc;
				//GetRgnBox(hRgn, &rc);
				GetClientRect(hWnd, &rc);
				InvalidateRect(hWnd, &rc, TRUE);
			}
			break;
		case IDM_TEST6:
			{
				//     
				DeleteObjects();

				hRgn = GetRgn(IDR_RGN3);
				RECT rc;
				//GetRgnBox(hRgn, &rc);
				GetClientRect(hWnd, &rc);
				InvalidateRect(hWnd, &rc, TRUE);
			}
			break;


		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	
	case WM_KEYDOWN:
		{
			//     
			ReturnView();
		}
		break;
	
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		{
			

			//  ,   ""  
			//      
			if(hBmp != NULL)
			{
				BITMAP bitmap;
				GetObject(hBmp, sizeof(BITMAP), &bitmap);
				DrawState(hdc, NULL, NULL, (LPARAM)hBmp, 0, 0,0,bitmap.bmWidth,bitmap.bmHeight, DST_BITMAP);
			}

			if(hRgn != NULL)
			{
				//    
				HBRUSH brush = CreateSolidBrush(RGB(255,255,255));
				//      1 
				FrameRgn(hdc, hRgn, brush, 1,1);
			}


		}
		EndPaint(hWnd, &ps);
		break;


	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}



//  
HRGN GetRgn(UINT id_res)
{
	//     
	HRSRC hrRgn = FindResource(hInst, MAKEINTRESOURCE(id_res),"RGN");

	//  
	LPRGNDATA pRgnData = (LPRGNDATA)LoadResource(hInst, hrRgn);

	//        
	HRGN rgn = ExtCreateRegion(NULL, SizeofResource(hInst,hrRgn), pRgnData);

	FreeResource(pRgnData);

	return rgn;
}


//   
void ViewChange()
{
	//  
	hMenu = GetMenu(hWnd);
	//    
	SetMenu(hWnd, NULL);

	//        
	//      
	DWORD dwStyle = ::GetWindowLong(hWnd, GWL_STYLE);
	DWORD dwNewStyle = (dwStyle & ~WS_OVERLAPPEDWINDOW);
	SetWindowLong(hWnd, GWL_STYLE, dwNewStyle);
}

//   
void ReturnView()
{
	DWORD dwStyle = ::GetWindowLong(hWnd, GWL_STYLE);
	DWORD dwNewStyle = (dwStyle | WS_OVERLAPPEDWINDOW);
	SetWindowLong(hWnd, GWL_STYLE, dwNewStyle);

	//  
	SetMenu(hWnd, hMenu);

	//    
	//       (HANDLE)
	SetWindowRgn(hWnd, NULL, TRUE);
}

void DeleteObjects()
{
	DELGDIOBJECT(hBmp);
	DELGDIOBJECT(hRgn);
}

